using System;
using System.Collections;
using System.Xml;
using ImportExport;

namespace XmlProvider
{
	/// <summary>
	/// Summary description for Class1.
	/// </summary>
	public class XmlProviderImpl : IImportExport
	{
		public XmlProviderImpl()
		{
		}

		#region IImportExport Members

		public void Export(IList data)
		{
			// criar documento XML (documento  construido totalmente em memria)
			XmlDocument doc = new XmlDocument();
			XmlElement root = doc.CreateElement("pessoas");
			foreach (PessoaInfo pi in data)
			{
				XmlElement no = doc.CreateElement("pessoa");
				no.SetAttribute("nome", pi.Nome);
				no.SetAttribute("idade", pi.Idade.ToString());

				root.AppendChild(no);
			}
			doc.AppendChild(root);

			// gravar documento em disco
			doc.Save(@"c:\temp\XmlProviderData.xml");
		}

		public IList Import()
		{
			// criar lista com base nos elementos existentes
			IList ret = new ArrayList();

			// ler documento do disco em modo streaming (optimiza utilizao de memoria)
			XmlReader reader = new XmlTextReader(@"c:\temp\XmlProviderData.xml");
			while (reader.Read()) 
			{
				if (reader.NodeType == XmlNodeType.Element && reader.Name == "pessoa")
				{
					string nome = reader.GetAttribute("nome");
					string idade = reader.GetAttribute("idade");

					PessoaInfo	pi = new PessoaInfo(nome, int.Parse(idade));
					ret.Add(pi);
				}
			}           
			reader.Close();	

			return ret;
		}

		#endregion
	}
}
